function [V_add,J] = add_points(V)
%ADD_POINTS adds lots of points to each side of V to isolate a ham-sandwich
%cut; J is a n integeer vector that marks original vertices, not that it should
%matter
m = size(V,1);
POINTS_PER_EDGE = 20;
LAMBDA = linspace(1,0,POINTS_PER_EDGE+2)'; LAMBDA= [LAMBDA, LAMBDA];
V_add = []; J = [];
for i = 1:m-1
    A1 = ones(POINTS_PER_EDGE+2,1)*V(i,:);
    A2 = ones(POINTS_PER_EDGE+2,1)*V(i+1,:);
    points_to_add = LAMBDA.*A1 + (1-LAMBDA).*A2;
    points_to_add = points_to_add(1:end-1,:);
    V_add = [V_add ; points_to_add];
    J = [J; i; zeros(POINTS_PER_EDGE,1)];
end
V_add(end+1,:) = V(end,:); J(end+1) = 1;