function A = area_cut_off_left(V,p1,p2)
%Computes the area cut off of a polygon V by a line; here p1 and p2 are
%points determining a line; if p1 or p2 is just a single integer, then it's
%a coordinate of V and should be treated so accordingly
k = size(V,1);
if length(p1) == 1 & length(p2) == 1
    %two polygon vertices; sort everything so that p1 comes first
    V = V([p1:end , 2:p1],:);
    if p2 > p1
        p2 = p2 - p1 + 1;
    else
        p2 = n - (p1 - p2);
    end
    A = polyarea(V(p2:end,1), V(p2:end,2));
elseif length(p1) == 1 & length(p2) == 2
    %one polygon vertex; get the intersection of p1 with p2, and make the
    %new vertex the one that's farther, etc
    [XI,YI] = intsecpl(V(:,1),V(:,2),[V(p1,1);p2(1)],[V(p1,2);p2(2)]);
    if length(XI) == 1
        v2 = [XI YI];
    elseif length(XI) == 2
        v2_1 = [XI(1) YI(1)]; v2_2 = [XI(2) YI(2)]; V2 = [v2_1 ; v2_2];
        S = [norm(v2_1 - V(p1,:)); norm(v2_2 - V(p1,:) )];
        [y,i] = max(S); v2 = V2(i,:);
    end
    %at this point, v2 should be the other intersection thing
    K = lies_to_left(V, V(p1,:), v2);
    V_sub = [V(p1,:) ; V(K,:) ; v2]; V_sub = V_sub(convhull(V_sub(:,1),V_sub(:,2)),:);
    A = polyarea(V_sub(:,1), V_sub(:,2));
elseif length(p1) == 2 & length(p2) == 1
    %one polygon vertex; get the intersection of p1 with p2, and make the
    %new vertex the one that's farther, etc
    [XI,YI] = intsecpl(V(:,1),V(:,2),[V(p2,1);p1(1)],[V(p2,2);p1(2)]);
    if length(XI) == 1
        v1 = [XI YI];
    elseif length(XI) == 2
        v1_1 = [XI(1) YI(1)]; v1_2 = [XI(2) YI(2)]; V1 = [v1_1 ; v1_2];
        S = [norm(v1_1 - V(p2,:)); norm(v1_2 - V(p2,:) )];
        [y,i] = max(S); v1 = V1(i,:);
    end
    %at this point, v1 should be the other intersection thing
    K = lies_to_left(V, p1, V(p2,:) );
    V_sub = [V(p2,:) ; V(K,:) ; v1]; V_sub = V_sub(convhull(V_sub(:,1),V_sub(:,2)),:);
    A = polyarea(V_sub(:,1), V_sub(:,2));
else
    [XI,YI] = intsecpl(V(:,1),V(:,2),[p1(1);p2(1)],[p1(2);p2(2)]);
    if size(XI) == 0
        %if V lies to the left of p1 p2 then it's all the area
        no = [p2(2) - p1(2);p1(1)- p2(1)];
        if find (V - ones(k,1)*p1 )*no' >0
            A = polyarea(V(:,1),V(:,2));
            return;
        else
            A =0;
            return;
        end
    end
    if size(XI) == 1
        disp('zots!')
        return;
    end
    [XI,i] = sort(XI);YI = YI(i);
    x1 = XI(1); x2 = XI(end); y1 = YI(1); y2 = YI(end);
    if norm([x1,y1]-p1) > norm([x1,y1]-p2), swap = [x1, y1]; x1 = x2; y1 = y2; x2 = swap(1); y2 = swap(2); end;
    %[x1,y1],[x2,y2] are intersections w/ polygon; find all the remaining ones
    %to the left of line p1p2
    % plot([p1(1),p2(1)],[p1(2),p2(2)],'or');pause;
    n = [y1-y2;x2-x1];
    S = (V-ones(k,1)*[x1,y1])*n;
    Vcut = V(find(S>0),:); Vcut = [ [x1;x2;Vcut(:,1)],[y1;y2;Vcut(:,2)] ];
    Vcut = Vcut(convhull(Vcut(:,1),Vcut(:,2)),:);
    A = polyarea(Vcut(:,1),Vcut(:,2));
end